#include <pspctrl.h>

#include "main.h"
#include "include/dxlibp.h"

static u32 Buttons;
static bool Flag;
static clock_t count;
/*
inline u32 GetButton(int firstwait, int wait)
{
	SceCtrlData pad;
	sceCtrlReadBufferPositive(&pad, 1);

	if(pad.Buttons == Buttons)
	{
		if(!Flag)
		{
			if(pad.TimeStamp - count < firstwait)
				return 0;
			Flag = true;
			count = pad.TimeStamp;

		 	goto end; 
		}
		if(pad.TimeStamp - count < wait)
			return 0;
		count = pad.TimeStamp;

		goto end;
	}

	Buttons = pad.Buttons;
	Flag = false;
	count = pad.TimeStamp;

	return pad.Buttons;

end:
	pad.Buttons &= PSP_CTRL_UP | PSP_CTRL_DOWN | PSP_CTRL_LEFT | PSP_CTRL_RIGHT;
	return pad.Buttons;
}
*/
inline u32 GetButton(int firstwait, int wait)
{
	int padButtons = GetInputState();

	if(padButtons == Buttons)
	{
		if(!Flag)
		{
			if(sceKernelLibcClock() - count < firstwait)
				return 0;
			Flag = true;
			count = sceKernelLibcClock();

			goto end;
		}
		if(sceKernelLibcClock() - count < wait)
			return 0;
		count = sceKernelLibcClock();

		goto end;
	}

	Buttons = padButtons;
	Flag = false;
	count = sceKernelLibcClock();

	return padButtons;

end:
	padButtons &= PSP_CTRL_UP | PSP_CTRL_DOWN | PSP_CTRL_LEFT | PSP_CTRL_RIGHT;
	return padButtons;
}
