#include "menu.h"
#include "treeview.h"
#include "file.h"
#include "property.h"
#include "include/dxlibp.h"
#include "rco.h"

#define CloseMenu() {MenuCursor = 0;MenuOpen = false;}

bool MenuOpen;

static int MenuCursor;
static const int CurPos[8] = {61, 83, 109, 131, 153, 179, 201, 223};	//ʒuϑIȂ̂ŌvZł͈ʒu͋߂Ȃc}uƂĔz

inline void ControlMenu(int Buttons)
{
	if(Buttons & DXP_INPUT_UP)
	{
		MenuCursor--;
		if(MenuCursor < 0)
			MenuCursor = 7;
	}
	else if(Buttons & DXP_INPUT_DOWN)
	{
		MenuCursor++;
		if(MenuCursor > 7)
			MenuCursor = 0;
	}
	else if(Buttons & DXP_INPUT_CIRCLE)
	{
		switch(MenuCursor)
		{
		case 0:
			{
				CreateFile();
				break;
			}
		case 1:
			{
				CreateFolder();
				ResetAllSelect();
				break;
			}
		case 2:
			{
				if(cp.Flag)
					FreeCopy();
				CreateCopy(false);
				ResetAllSelect();
				break;
			}
		case 3:
			{
				if(cp.Flag)
					FreeCopy();
				CreateCopy(true);
				ResetAllSelect();
				break;
			}
		case 4:
			{
				if(cp.Flag)
				{
					Paste();
					Mode = MODE_PROGRESS;
				}
				break;
			}
		case 5:
			{
				RemoveOfList();
				Mode = MODE_PROGRESS;
				break;
			}
		case 6:
			{
				if(cp.Flag)
					FreeCopy();
				FileRename();
				ResetAllSelect();
				break;
			}
		case 7:
			{
				if(cursor->Ext == FOLDER)
				{
					CompressZip();
					Mode = MODE_PROGRESS;
				}
				else
				{
					if(InitProperty())
						Mode = MODE_PROPERTY;
				}
				ResetAllSelect();
				break;
			}
		}
		CloseMenu();
	}
	else if(Buttons & DXP_INPUT_CROSS)
	{
		CloseMenu();
		ResetAllSelect();
	}
}

inline void DrawMenu()
{
	DrawGraph(250, 58, Menu, true);
	if(!cp.Flag && MenuCursor == 4)	//\tłȂƂO[J[\
		DrawGraph(253, CurPos[4], Select[3], false);
	else
		DrawGraph(253, CurPos[MenuCursor], Select[2], false);
	DrawGraph(260, 64, Extention[1], true);
	DrawGraph(260, 86, Extention[0], true);
	if(cursor->Ext == FOLDER)
		DrawGraph(260, 226, Extention[4], true);

	DrawString(285, 65, cfg.CreateFile, BLACK, 0);
	DrawString(285, 87, cfg.CreateFolder, BLACK, 0);
	DrawString(285, 113, cfg.Copy, BLACK, 0);
	DrawString(285, 135, cfg.Move, BLACK, 0);
	DrawString(285, 157, cfg.Paste, cp.Flag ? BLACK : GRAY, 0);
	DrawString(285, 183, cfg.Remove, BLACK, 0);
	DrawString(285, 205, cfg.Rename, BLACK, 0);
	DrawString(285, 227, cursor->Ext == FOLDER ? cfg.CompressZip : cfg.Property, BLACK, 0);
}