#include <string.h>

#include "main.h"
#include "treeview.h"
#include "memory.h"
#include "include/dxlibp.h"

static SceIoStat *stat;

bool InitProperty()
{
	stat = APImalloc(sizeof(SceIoStat));
	if(!stat)
		return false;
	memset(stat, 0, sizeof(SceIoStat));
	sceIoGetstat(cursor->FullPath, stat);

	return true;
}

inline void DrawProperty()
{
	DrawString(0, 0, "vpeB", BLACK, 0);
	DrawString(0, 30, "t@C̎:", BLACK, 0);
	DrawFormatString(100, 30, BLACK, "(%s)", strrchr(cursor->FullPath, '.'));
	DrawString(0, 50, "ꏊ:", BLACK, 0);
	DrawString(100, 50, cursor->FullPath, BLACK, 0);
	DrawString(0, 70, "TCY:", BLACK, 0);
	if(1000 * 1000 * 1000 < stat->st_size)	//TCYfJ΂ꑊ̒PʂɁB
		DrawFormatString(100, 70, BLACK, "%1.2f GB(%d oCg)", (double)stat->st_size / (1000.0 * 1000.0 * 1000.0), stat->st_size);
	else if(1000 * 1000 < stat->st_size)
		DrawFormatString(100, 70, BLACK, "%1.2f MB(%d oCg)", (double)stat->st_size / (1000.0 * 1000.0), stat->st_size);
	else
		DrawFormatString(100, 70, BLACK, "%1.2f KB(%d oCg)", (double)stat->st_size / 1000.0, stat->st_size);
	DrawString(0, 90, "쐬:", BLACK, 0);
	DrawFormatString(100, 90, BLACK, "%dN%d%dA%02d:%02d:%02d", stat->st_ctime.year, stat->st_ctime.month, stat->st_ctime.day, stat->st_ctime.hour, stat->st_ctime.minute, stat->st_ctime.second);
	DrawString(0, 110, "XV:", BLACK, 0);
	DrawFormatString(100, 110, BLACK, "%dN%d%dA%02d:%02d:%02d", stat->st_mtime.year, stat->st_mtime.month, stat->st_mtime.day, stat->st_mtime.hour, stat->st_mtime.minute, stat->st_mtime.second);
	DrawString(0, 130, "ANZX:", BLACK, 0);
	DrawFormatString(100, 130, BLACK, "%dN%d%dA%02d:%02d:%02d", stat->st_atime.year, stat->st_atime.month, stat->st_atime.day, stat->st_atime.hour, stat->st_atime.minute, stat->st_atime.second);
}

inline void ControlProperty(int Buttons)
{
	if(Buttons & DXP_INPUT_CROSS)
	{
		APIfree(stat);
		Mode = MODE_MAIN;
	}
}