#ifndef TREEVIEW_H
#define TREEVIEW_H

#include "main.h"
#include "util.h"

typedef struct SceIoDirent_Kai{
	char *FullPath;	//tpX(mۂ)
	char *Name;	//tpX̃t@C
	Extentions Ext;	//gq
	bool Opened;	//tH_JĂ邩
	bool Selected;	//I𒆂
	bool CopyMark;	//Rs[̃}[N
	struct SceIoDirent_Kai *parent;
	struct SceIoDirent_Kai *child;
	struct SceIoDirent_Kai *prev;
	struct SceIoDirent_Kai *next;
}SceIoDirent_Kai;

extern int	ViewCount,
			TreeCursor,
			TreeScroll;
extern SceIoDirent_Kai	*head,
						*cursor;

/*--------------------------------------------------------------------------------------------------
t@CXgp̍\̃XgɊi[
DirName:t@CXg擾tH_
Count:擾t@Ci[ϐ̃|C^
return:擾Xg̐擪|C^
--------------------------------------------------------------------------------------------------*/
SceIoDirent_Kai *GetDirectory(char *DirName, int *Count);

/*--------------------------------------------------------------------------------------------------
t@CXgSĊJ
head:Jt@CXgi[ȎQƍ\̃Xg̐擪̃|C^
--------------------------------------------------------------------------------------------------*/
void FreeDirectory(SceIoDirent_Kai *head);

/*--------------------------------------------------------------------------------------------------
tH_J
--------------------------------------------------------------------------------------------------*/
void MakeTree();

/*--------------------------------------------------------------------------------------------------
tH_
--------------------------------------------------------------------------------------------------*/
void CloseTree();

/*--------------------------------------------------------------------------------------------------
J[\ƃXN[̈ʒu
--------------------------------------------------------------------------------------------------*/
void AdjustCursorAndScroll();

/*--------------------------------------------------------------------------------------------------
Vł̂蓮ŃXgɂȂB
--------------------------------------------------------------------------------------------------*/
void AddOneFileToList(SceIoDirent_Kai *newp);

/*--------------------------------------------------------------------------------------------------
Xg菜
--------------------------------------------------------------------------------------------------*/
void RemoveOneFileFromList(SceIoDirent_Kai *old);

/*--------------------------------------------------------------------------------------------------
SĂ̕I菜
--------------------------------------------------------------------------------------------------*/
void ResetAllSelect();

/*--------------------------------------------------------------------------------------------------
݂̏Ԃŕ\t@CԂ
return:\鑍t@C
--------------------------------------------------------------------------------------------------*/
int GetViewCount();

/*--------------------------------------------------------------------------------------------------
c[̃uEU̕`
--------------------------------------------------------------------------------------------------*/
inline void DrawTreeView();

/*--------------------------------------------------------------------------------------------------
c[uEȖ
--------------------------------------------------------------------------------------------------*/
inline void ControlTreeView(int Buttons);

#endif