#include <string.h>
#include "progress.h"
#include "include/dxlibp.h"

Progress pb;
extern int Mode;

void GetProgress(unsigned int Success, unsigned int Max, char *Name)
{
	pb.Success = Success;
	pb.Max = Max;
	strcpy(pb.Name, Name);
	sceKernelDelayThread(1);
}

inline void DrawProgress(int ProgressBar)
{
	int i;
	DrawString(0, 0, pb.Name, BLACK, 0);
	DrawGraph(90, 120, ProgressBar, false);
	int Per = 100 * pb.Success / pb.Max;
	pb.Cancel = false;
	for(i = 0; i < Per * 296 / 100; i++)
		DrawRectGraph(92 + i, 121, 2, 1, 1, 21, ProgressBar, false, false);
}

inline void ControlProgress(int Buttons)
{
	if(pb.Finish)	//I̍}ƂƂƏIĂ܂傤
	{
		pb.Success = pb.Max = 0;
		Mode = MODE_MAIN;
		pb.Finish = false;
	}
	else if(Buttons & DXP_INPUT_CROSS)
	{
		pb.Success = pb.Max = 0;
		Mode = MODE_MAIN;
		pb.Cancel = true;
	}
}